#Boss Battle Level

var int muro_in_danger=0;
var int count_swat_dies=3;
var int round2_spawned=0;
var int counter=2;
var int my_save_point=0;

func void main (void) {

	gl_fog_blue=0
	gl_fog_red=0
	gl_fog_green=0
	gl_fog_start=.995
	gs_farclipplane_set 1500
		
	ui_suppress_prompt = 1
	my_save_point = save_point;	
		
	if (my_save_point eq 0){	
	tctf
	}

	if (my_save_point eq 1){
	roof
	}
	
	if (my_save_point eq 2){
	dream
	}
	
	if (my_save_point eq 3){
	compound
	}
	
	if (my_save_point eq 4){
	irondemon
	}	
}


func void tctf(void){
	ai2_allpassive(0)
	particle roof_doors_locklight01 do start
	powerup_spawn hypo 1901
	powerup_spawn hypo 1902
	weapon_spawn w1_tap 1903
	powerup_spawn ammo 1904
	powerup_spawn ammo 1905
	powerup_spawn shield 1906
	
	
	chr_teleport 0 1900
	chr_facetoflag 0 1900
	chr_givepowerup 0 hypo 1
	dmsg ("Prepare yourself for the Boss Battle")
	dmsg ("Round One - Barabus")
	sleep 120
	
	ai2_spawn barabus
	chr_boss_shield barabus
	#ai2_spawn hardelite
	sound_music_start mus_asianb
	
	chr_wait_health barabus 1
	sound_music_stop mus_asianb
	ai2_allpassive(1)
	dmsg ("One down...")
	dmsg ("Hypo added")
	sleep 60
	chr_animate 0 KONOKOendpowerup
	chr_givepowerup 0 hypo 1
	sleep 360	 
	roof	
}		
	
				
func void roof(void){
	ai2_allpassive(0)
	gl_fog_start=.975
	gs_farclipplane_set 900
	powerup_spawn hypo 9509
	powerup_spawn hypo 9539
	powerup_spawn cell 8600
	weapon_spawn w6_vdg 8601
	
	
	chr_set_class 0 k4_F
	chr_teleport 0 9523
	chr_facetoflag 0 9523
	if (my_save_point ne 1)
		{
		save_game 1 autosave
		}
		else
		{
		dmsg "Restore save point1"
		restore_game
		}
	
	dmsg ("Round Two - Mukade")
	sleep 120
	
	ai2_spawn mukade
	chr_boss_shield mukade
	#ai2_spawn hardninja
	sound_music_start mus_fitec
	chr_inv_reset mukade
	chr_wait_health mukade 1 
	sound_music_stop mus_fitec
	ai2_allpassive(1)
	dmsg ("Two down...")
	dmsg ("Hypo added")
	sleep 60
	chr_animate 0 KONOKOendpowerup
	chr_givepowerup 0 hypo 1
	sleep 360
	dream
}

func void dream(void){
	ai2_allpassive(0)
	gs_farclipplane_set 1000
	particle fog_floor1 do start
	gl_fog_start_changeto .9 12
	powerup_spawn hypo 112
	powerup_spawn hypo 113
	powerup_spawn invis 114
	powerup_spawn ammo 115
	
	chr_set_class 0 k4_G
	chr_teleport 0 111
	chr_facetoflag 0 111
	if (my_save_point ne 2)
		{
		save_game 2 autosave
		}
		else
		{
		dmsg "Restore save point 2"
		restore_game
		}
	
	dmsg ("Round Three - Evil Konoko")
	sleep 120
	
	ai2_spawn evilkonoko
	#ai2_spawn hardfury
	sound_music_start mus_wls
	
	chr_wait_health evilkonoko 1 
	sound_music_stop mus_wls
	ai2_allpassive(1)
	dmsg ("Three down...")
	dmsg ("Hypo added")
	sleep 60
	chr_animate 0 KONOKOendpowerup
	chr_givepowerup 0 hypo 1
	sleep 360
	compound
}	
		
func void compound(void){	
	ai2_allpassive(0)
	gl_fog_start=.985		
	gs_farclipplane_set 1000
	particle dishpulse do start
	particle peak do start
	particle sturm_ambient start
	
	
	powerup_spawn hypo 522
	powerup_spawn ammo 523
	
	chr_set_class 0 k4_K
	chr_teleport 0 512
	chr_facetoflag 0 512
	if (my_save_point ne 3)
		{
		save_game 3 autosave
		}
		else
		{
		dmsg "Restore save point 3"
		restore_game
		}
	
	dmsg ("Round Four - Muro")
	sleep 120
	sound_ambient_start mc_dish_loop 0.6
	sound_music_start mus_ot
	ai2_boss_battle = 1
	ai2_spawn Griffin_Swat
	ai2_spawn GrifOps02
	ai2_spawn GrifOps03			
	ai2_spawn Muro
	chr_boss_shield Muro
	ai2_spawn GrifElite01
	ai2_spawn GrifElite02
	ai2_spawn GrifElite03
	chr_set_health Muro 500
	fork wait_to_help	
	
	chr_wait_health Muro 1 
	ai2_allpassive(1)
	sound_ambient_stop mc_dish_loop
	sound_music_stop mus_ot
	dmsg ("Four down...")
	dmsg ("Hypo added")
	sleep 60
	
	chr_animate 0 KONOKOendpowerup
	chr_givepowerup 0 hypo 1
	sleep 360
	fork irondemon
}
	


func void irondemon(string ai_name){
	ai2_allpassive(0)
	gl_fog_blue=.15
	gl_fog_red=.15
	gl_fog_green=.15
	gl_fog_start=.99
	gs_farclipplane_set 1400
	
	if (my_save_point ne 4)
		{
		save_game 4 autosave
		}
	
	chr_set_class 0 konoko_generic
	chr_full_health 0
	chr_teleport 0 20
	chr_facetoflag 0 20
	chr_giveweapon 0 w15a_smg
	chr_givepowerup 0 shield
	chr_givepowerup 0 hypo 6
	chr_givepowerup 0 ammo 6
	chr_givepowerup 0 cell 6
	save_point_4
	
	dmsg ("Bonus Round")
	dmsg ("Iron Demon")
	sleep 120
	sound_music_start mus_ambgrv2
	
	weapon_spawn w27_dev 16
	weapon_spawn w23_rla 17
	ai2_spawn griffin
	chr_teleport griffin 21
	chr_facetoflag griffin 21
	chr_giveweapon griffin w15a_smg
	chr_givepowerup griffin ammo 6
	chr_givepowerup griffin cell 6
	chr_givepowerup griffin shield
	
	ai2_spawn swat
	chr_teleport swat 21
	chr_facetoflag swat 21
	chr_giveweapon swat w25_chg
	chr_givepowerup swat ammo 6
	chr_givepowerup swat cell 6
	chr_givepowerup swat shield
	
	ai2_spawn swat2
	chr_teleport swat2 23
	chr_facetoflag swat2 23
	chr_giveweapon swat2 w25_chg
	chr_givepowerup swat2 ammo 6
	chr_givepowerup swat2 cell 6
	chr_givepowerup swat2 shield
	
	ai2_spawn swatops1
	chr_teleport swatops1 22
	chr_facetoflag swatops1 22
	chr_giveweapon swatops1 w3_phr
	chr_givepowerup swatops1 cell 6
	chr_givepowerup swatops1 ammo 6
	chr_givepowerup swatops1 shield
	
	ai2_spawn swatops2
	chr_teleport swatops2 22
	chr_facetoflag swatops2 22
	chr_giveweapon swatops2 w3_phr
	chr_givepowerup swatops2 cell 6
	chr_givepowerup swatops2 ammo 6
	chr_givepowerup swatops2 shield
	
	ai2_spawn swatops3
	chr_teleport swatops3 23
	chr_facetoflag swatops3 23
	chr_giveweapon swatops3 w3_phr
	chr_givepowerup swatops3 cell 6
	chr_givepowerup swatops3 ammo 6
	chr_givepowerup swatops3 shield
	
	ai2_spawn Iron_Demon
	chr_boss_shield Iron_Demon
	chr_teleport Iron_Demon 1
	chr_facetoflag Iron_Demon 1
	ai2_makeblind Iron_Demon 1
	ai2_makedeaf Iron_Demon 1
	chr_giveweapon Iron_Demon w45_ID2
	
	ai2_spawn guard_dog1
	chr_teleport guard_dog1 8
	chr_facetoflag guard_dog1 8
	
	ai2_spawn guard_dog2
	chr_teleport guard_dog2 6
		
	ai2_spawn guard_dog3
	chr_teleport guard_dog3 15
	chr_facetoflag guard_dog3 15
	
	ai2_spawn guard_dog4
	chr_teleport guard_dog4 2
	chr_boss_shield guard_dog4
	
	ai2_spawn Sentry
	chr_boss_shield Sentry
	chr_teleport Sentry 9
		
	sleep 240
	fork followme
	fork giveweapon
	
	chr_wait_health Iron_Demon 1
	chr_invincible 0 1
	ai2_allpassive(1)
	sound_music_stop mus_ambgrv2
	slowmo(600)
	dmsg ("Awesome job!!!")
	dmsg ("Victory is yours!")
	sleep 800
	chr_invincible 0 0
	win
}	
	


func void
BarabasNorth(string barabas)
{
	cutscene_sync mark
	sound_ambient_start c11_10_14bar_jet
	playback barabus BarabasNorth
	ai2_barabbas_retrievegun barabus
	sleep 60
	chr_envanim barabus BarabasNorthBox norotation
	chr_animate barabus BARABnorth
	sleep 105
	#particle BarabasNorth do start
}



func void
BarabasSouth(string barabas)
{
	cutscene_sync mark
	sound_ambient_start c11_10_14bar_jet
	playback barabus BarabasSouth
	ai2_barabbas_retrievegun barabus
	sleep 60
	chr_envanim barabus BarabasSouthBox norotation
	chr_animate barabus BARABsouth
	sleep 105
	#particle BarabasSouth do start
}


func void
BarabasEast(string barabas)
{
	cutscene_sync mark
	sound_ambient_start c11_10_14bar_jet
	playback barabus BarabasEast
	ai2_barabbas_retrievegun barabus
	sleep 60
	chr_envanim barabus BarabasEastBox norotation
	chr_animate barabus BARABeast
	sleep 105
	#particle BarabasEast do start
}



func void
BarabasWest(string barabas)
{
	cutscene_sync mark
	sound_ambient_start c11_10_14bar_jet
	playback barabus BarabasWest
	ai2_barabbas_retrievegun barabus
	sleep 60
	chr_envanim barabus BarabasWestBox norotation
	chr_animate barabus BARABwest
	sleep 105
	#particle BarabasWest do start

}

func void wait_to_help(void)
{
	chr_wait_health Muro 200
	
	dprint MURO_IN_DANGER
	ai2_boss_battle = 0;
	muro_in_danger = 1;
	ai2_attack GrifElite01 char_0
	ai2_attack GrifElite02 char_0
	ai2_attack GrifElite03 char_0
	ai2_attack GrifElite04 char_0
	ai2_attack GrifElite05 char_0
	ai2_attack GrifElite06 char_0
}

func void check_death1a(string ai_name)
{
	dprint death1a
	Round2a
}

func void check_death1b(string ai_name)
{
	dprint death1a
	Round2b
}

func void final_round(string ai_name)
{
	dprint check_ROUND_3
	counter = counter - 1
	if(counter eq 0)
	{
		Round3
	}
}



func void Round2a(string ai_name)
{
	dprint ROUND_2a
	round2_spawned = round2_spawned + 1;

	ai2_spawn GrifElite04

	ai2_passive GrifElite04 1

	playback_block GrifElite04 GrifWave2_Run1

	ai2_passive GrifElite04 0

	if (muro_in_danger eq 1) {
		# force the backup to go after konoko only
		ai2_attack GrifElite04 char_0
	}
	if (muro_in_danger eq 0) {
		ai2_makeaware GrifElite04 char_0
	}
}

func void Round2b(string ai_name)
{
	dprint ROUND_2b
	round2_spawned = round2_spawned + 1;

	ai2_spawn GrifElite05

	ai2_passive GrifElite05 1

	playback_block GrifElite05 GrifWave2_Run1

	ai2_passive GrifElite05 0

	if (muro_in_danger eq 1) {
		# force the backup to go after konoko only
		ai2_attack GrifElite05 char_0
	}
	if (muro_in_danger eq 0) {
		ai2_makeaware GrifElite05 char_0
	}
}

func void Round3(string ai_name)
{
	dprint ROUND_3
	round2_spawned = round2_spawned + 1;

	ai2_spawn GrifElite06

	ai2_passive GrifElite06 1

	playback_block GrifElite06 GrifWave2_Run3

	ai2_passive GrifElite06 0


	if (muro_in_danger eq 1) {
		# force the backup to go after konoko only
		ai2_attack GrifElite06 char_0
	}
	if (muro_in_danger eq 0) {
		# go after other dudes
		ai2_makeaware GrifElite06 char_0
	}
}
		
		
func void swat_dies(void)
{
	count_swat_dies = count_swat_dies - 1;
	if(count_swat_dies eq 0)
	{
		ai2_attack GrifElite01 char_0
		ai2_attack GrifElite02 char_0
		ai2_attack GrifElite03 char_0
		ai2_attack GrifElite04 char_0
		ai2_attack GrifElite05 char_0
	}
}

		
func void respawn(void) {
sleep 120
lose
}
		
		
func void followme(void)
{
		ai2_setmovementmode griffin run
		ai2_followme griffin
		ai2_setmovementmode swat run
		ai2_followme swat
		ai2_setmovementmode swat2 run
		ai2_followme swat2
		ai2_setmovementmode swatops1 run
		ai2_followme swatops1
		ai2_setmovementmode swatops2 run
		ai2_followme swatops2
		ai2_setmovementmode swatops3 run
		ai2_followme swatops3
		
		sleep 30
		fork followme
}

func void giveweapon(void)
{		chr_wait_animation(0, KONOKOjump_bk_crouch);
		chr_giveweapon griffin w15a_smg
		chr_giveweapon swat w25_chg
		chr_giveweapon swat2 w25_chg
		chr_giveweapon swatops1 w3_phr
		chr_giveweapon swatops2 w3_phr
		chr_giveweapon swatops3 w3_phr
		sleep 30
		fork giveweapon
}

func void noblind(void)
{	
	
	ai2_makeblind Iron_Demon 0
	ai2_makedeaf Iron_Demon 0
	ai2_makeblind guard_dog1 0
	ai2_makedeaf guard_dog1 0
	sleep 240
	door_lock 8
	door_lock 9
}





	
